/*
 * OCSP responder
 * by Massimiliano Pala (madwolf@openca.org)
 * OpenCA project 2001
 *
 * Copyright (c) 2001 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

#include "general.h"
#include "support.h"

#include <sys/types.h>
#include <unistd.h>
#include <pwd.h>
#include <grp.h>

/* #define	BUFF_MAX_SIZE	2048 */

/* Functions */
int strncmp_nocase( char *st1, char *st2, int n) {
	int i;

	if(!st1) return(-1);
	if(!st2) return(1);
	if( n<1 ) return (0);

	for( i=0; i<n; i++ ) {
		unsigned char *pnt_a, *pnt_b;
		unsigned char a, b;

		pnt_a = (unsigned char *) st1+i;
		pnt_b = (unsigned char *) st2+i;

		if( !pnt_a &&  pnt_b ) return(-1);
		if(  pnt_a && !pnt_b ) return(1);
		if( !pnt_a && !pnt_b ) return(0);

		a = tolower( *pnt_a );
		b = tolower( *pnt_b );

		if( a != b ) {
			return ( a-b );
		}
	}

	return(0);

}

char * strstr_nocase ( char *buf, char *string ) {

	int buf_len, string_len;
	int j,k;
	int match;

	char *ret = NULL;

	if( !buf || !string ) return (NULL);

	if( (buf_len = strlen(buf)) == 0 ) return(NULL);
	if( (string_len = strlen(string)) == 0 ) return(NULL);
	
	j = 0; match = 0;
	while( j < buf_len ) {
		unsigned char a, b;
		unsigned char *pnt_a, *pnt_b;

		pnt_a = (unsigned char *) (buf+j);
		pnt_b = (unsigned char *) (string);

		for( k = 0; k < string_len; k++ ) {
			a = (unsigned char) tolower(*(buf+j+k));
			b = (unsigned char) tolower(*(string+k));
			if( b != a ) {
				match=0;
				break;
			} else {
				match=1;
			}
		}
		if( match == 1 ) {
			return( buf+j );
		}
		j++;
	}

	return(ret);
}

/*
URL *getParsedUrl ( char *url_s ) {

	URL *ret = NULL;
	char *tmp_s = NULL;
	char *tmp_s2 = NULL;
	char *tmp_s3 = NULL;
	int len;

	if( !url_s ) return NULL;

	ret = (URL *) OPENSSL_malloc ( sizeof( URL ));
	if( !ret ) return NULL;

	memset( ret, 0, sizeof(struct url_data));
	ret->addr = NULL;
	ret->pwd = NULL;
	ret->usr = NULL;
	ret->port= 0;

	if( strncmp_nocase("ldap://", url_s, 6 ) == 0) {
		ret->proto = OCSP_CRL_PROTO_LDAP;
		ret->port = OCSP_DEFAULT_LDAP_PORT;
		//
		// ret->addr = (char *) OPENSSL_malloc ( BUFF_MAX_SIZE );
		// bzero( ret->addr, BUFF_MAX_SIZE );
		//

		tmp_s = &url_s[7];

		if( (tmp_s3 = strchr(tmp_s, '@')) != NULL ) {
			tmp_s2 = strchr( tmp_s, ':' );

			if( !tmp_s2 || (tmp_s3 < tmp_s2)) {
				return NULL;
			}
			len = (int) ( (long) tmp_s2 - (long) tmp_s );
			ret->usr = (char *) OPENSSL_malloc (len+1);
			bzero( ret->usr, len+1);
			strncpy( ret->usr, tmp_s, len);
			ret->usr[len] = '\x0';
			
			tmp_s = tmp_s2+1;
			tmp_s2 = strchr( tmp_s,'@');

			len = (int) ( (long) tmp_s2 - (long) tmp_s );
			ret->pwd = (char *) OPENSSL_malloc (len+1);
			bzero( ret->pwd, len+1);
			strncpy( ret->pwd, tmp_s, len);
			ret->pwd[len] = '\x0';

			tmp_s = tmp_s2+1;
		}

		if( strchr( tmp_s, ':' )) {
			tmp_s2 = strchr(tmp_s,':');

			len = (int) ( (long) tmp_s2 - (long) tmp_s );
			ret->addr = (char *) OPENSSL_malloc (len+1);
			bzero(ret->addr, len+1);
			strncpy( ret->addr, tmp_s, len);
			ret->addr[len] = '\x0';

			tmp_s = tmp_s2+1;
			ret->port = atoi( tmp_s );
		} else {
			ret->addr = (char *) OPENSSL_malloc ( BUFF_MAX_SIZE );
			bzero( ret->addr, BUFF_MAX_SIZE );

			strncpy( ret->addr, tmp_s, BUFF_MAX_SIZE);
			ret->port = OCSP_DEFAULT_LDAP_PORT;
		}

	} else if (strncmp_nocase( "file://", url_s, 6 ) == 0) {
		ret->port = -1;
		ret->proto = OCSP_CRL_PROTO_FILE;
		ret->addr = (char *) OPENSSL_malloc ( BUFF_MAX_SIZE );
		bzero( ret->addr, BUFF_MAX_SIZE );

		strncpy( ret->addr, &url_s[7], BUFF_MAX_SIZE);
	} else if( strncmp_nocase("http://", url_s, 6 ) == 0) {
		ret->proto = OCSP_CRL_PROTO_HTTP;
		tmp_s = &url_s[7];

		if( (tmp_s3 = strchr(tmp_s, '@')) != NULL ) {
			tmp_s2 = strchr( tmp_s, ':' );

			if( !tmp_s2 || (tmp_s3 < tmp_s2)) {
				return NULL;
			}
			len = (int) ( (long) tmp_s2 - (long) tmp_s );
			ret->usr = (char *) OPENSSL_malloc (len+1);
			bzero( ret->usr, len+1);

			strncpy( ret->usr, tmp_s, len);
			ret->usr[len] = '\x0';
			
			tmp_s = tmp_s2+1;
			tmp_s2 = strchr( tmp_s,'@');

			len = (int) ( (long) tmp_s2 - (long) tmp_s );
			ret->pwd = (char *) OPENSSL_malloc (len+1);
			bzero( ret->pwd, len+1);
			strncpy( ret->pwd, tmp_s, len);
			ret->pwd[len] = '\x0';

			tmp_s = tmp_s2+1;

		}

		if( strchr( tmp_s, ':' )) {
			tmp_s2 = strchr(tmp_s,':');

			len = (int) ( (long) tmp_s2 - (long) tmp_s );
			ret->addr = (char *) OPENSSL_malloc (len+1);
			bzero( ret->addr, len+1 );

			strncpy( ret->addr, tmp_s, len);
			ret->addr[len] = '\x0';

			tmp_s = tmp_s2+1;
			ret->port = atoi( tmp_s );
			if( (tmp_s2 = strchr( tmp_s, '/' )) != NULL ) {
				tmp_s =  tmp_s2;
			} else {
				tmp_s = &url_s[7];
			}
		} else {
			ret->port = OCSP_DEFAULT_HTTP_PORT;
		}

		if( strchr( tmp_s, '/' )) {

			tmp_s2 = strchr(tmp_s,'/');

			if( !ret->addr ) {
				len = (int) ( (long) tmp_s2 - (long) tmp_s );
				ret->addr = (char *) OPENSSL_malloc (len+1);
				bzero( ret->addr, len+1);
				strncpy( ret->addr, tmp_s, len);
				ret->addr[len] = '\x0';
			}

			tmp_s = tmp_s2;
			ret->path = strdup( tmp_s );
		} else {
			if( !ret->addr )
				ret->addr = strdup( tmp_s );
			ret->path = "/";
		}

	} else {
		OPENSSL_free( ret );
		return NULL;
	}

	return ret;
}
*/

int set_privileges( OCSPD_CONFIG *conf ) {

	struct passwd *pw = NULL;
	struct group *gr = NULL;

	if( (gr = getgrnam( conf->group ) ) == NULL ) {
		syslog( LOG_ERR, "Cannot find group %s", conf->group);
		return 0;
	}
	
	if( (pw = getpwnam( conf->user ) ) == NULL ) {
		syslog( LOG_ERR, "Cannot find user %s", conf->user);
		return 0;
	}

	if (setgid (gr->gr_gid) == -1) {
		syslog(LOG_ERR, "Error setting group %d (%s)", 
			gr->gr_gid, conf->group);
		return 0;
	}

#ifdef HAVE_SETGROUPS
	setgroups(1, &gr->gr_gid);
#endif

	if (setuid (pw->pw_uid) == -1) {
		syslog(LOG_ERR,"Error setting user %d (%s)", 
						pw->pw_uid, conf->user );
		return 0;
	}

	return 1;
}

int set_chroot( OCSPD_CONFIG *conf ) {

	if( (!conf) || (!conf->chroot_dir))
		return(1);

	/* Now chroot the running process before starting the server */
	if( chdir ( conf->chroot_dir ) != 0 ) {
		/* Error in changing to working directory */
		syslog(LOG_ERR,"SECURITY::CHROOT::ERROR [%s]",
			strerror(errno));
		perror(NULL);
		return(0);
	}

	if( chroot( conf->chroot_dir ) != 0 ) {
		/* Error chrooting the process */
		syslog(LOG_ERR,"SECURITY::CHROOT::ERROR [%s]",
			strerror(errno));
		perror(NULL);
		return(0);
	}

	syslog(LOG_INFO,"SECURITY::CHROOT::Completed [%s]",
		conf->chroot_dir );

	/* Ok, chdir and chroot! */
	return(1);
}
